program n_subwalk_pingmode;

{$mode objfpc}{$H+}
{$define UseCThreads}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes, SysUtils, CustApp
  { you can add units after this }, pingsend, net_threads;

type

  { TMyApplication }

  TMyApplication = class(TCustomApplication)
  protected
    procedure DoRun; override;
  public
    n_threads: array [1..255] of nThread;
  end;

{ TMyApplication }

procedure TMyApplication.DoRun;
var host: string;
    tm:   integer;
    I:    integer;
begin
  if ParamStr(1) <> '' then begin
    host := ParamStr(1);
  end
  else begin
    halt;
  end;
  if ParamStr(2) <> '' then begin
    tm   := StrToInt(ParamStr(2));
  end
  else begin
    halt;
  end;

  for I:=1 to 255 do begin
    n_threads[I] := nThread.Create(true);
    n_threads[I].host := host + '.' + inttostr(I);
    n_threads[I].tm   := tm;
    n_threads[I].Resume;
  end;

  for I:=1 to 255 do begin
    while (n_threads[I].run) do begin
    end;
     if n_threads[I].state = true then begin
       writeln(n_threads[I].res);
     end;
   n_threads[I].Free;
  end;
  { add your program here }

  // stop program loop
  Terminate;
end;

var
  Application: TMyApplication;
begin
  Application:=TMyApplication.Create(nil);
  Application.Run;
  Application.Free;
end.

